<img src="https://raw.githubusercontent.com/js-data/js-data/master/js-data.png" alt="js-data logo" title="js-data" align="right" width="96" height="96" />

# js-data-adapter-tests

[![Slack Status][sl_b]][sl_l]
[![npm version][npm_b]][npm_l]
[![Circle CI][circle_b]][circle_l]
[![npm downloads][dn_b]][dn_l]

Tests for [js-data](http://www.js-data.io/) adapters.

## Usage

### Node.js

```
npm install --save-dev js-data-adapter-tests mocha sinon chai babel-polyfill
```

`mocha.start.js`:

```js
require('babel-polyfill')

var JSData = require('js-data')
var JSDataAdapterTests = require('js-data-adapter-tests')
var MyAdapter = require('./')

global.assert = JSDataAdapterTests.assert;
global.sinon = JSDataAdapterTests.sinon;

JSDataAdapterTests.init({
  // minimum required config
  JSData: JSData,
  Adapter: MyAdapter
})
```

### Karma

```
npm install --save-dev js-data-adapter-tests mocha sinon chai babel-polyfill karma karma-mocha karma-sinon karma-chai
```

`karma.start.js`:

```js
// babel-polyfill should be included by karma.conf.js

window.assert = JSDataAdapterTests.assert
// sinon should be loaded by karma.conf.js

JSDataAdapterTests.init({
  // minimum required config
  JSData: JSData,
  Adapter: MyAdapter
})
```

See [js-data-rethinkdb](https://github.com/js-data/js-data-rethinkdb/blob/master/mocha.start.js) for a Node.js example.

See [js-data-localstorage](https://github.com/js-data/js-data-localstorage/blob/master/karma.start.js) for a Karma example.

### Changelog
[CHANGELOG.md](https://github.com/js-data/js-data-adapter-tests/blob/master/CHANGELOG.md)

### Community
- [Slack Channel](http://slack.js-data.io) - Better than IRC!

### License

The MIT License (MIT)

Copyright (c) 2014-2016 Jason Dobry

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

[sl_b]: http://slack.js-data.io/badge.svg
[sl_l]: http://slack.js-data.io
[npm_b]: https://img.shields.io/npm/v/js-data-adapter-tests.svg?style=flat
[npm_l]: https://www.npmjs.org/package/js-data-adapter-tests
[circle_b]: https://img.shields.io/circleci/project/js-data/js-data-adapter-tests/master.svg?style=flat
[circle_l]: https://circleci.com/gh/js-data/js-data-adapter-tests/tree/master
[dn_b]: https://img.shields.io/npm/dm/js-data-adapter-tests.svg?style=flat
[dn_l]: https://www.npmjs.org/package/js-data-adapter-tests
